if(typeof $ == "undefined") {
	alert('JQuery not loaded');
}

var slideParsers = {
	clouds : function(slide) {
		var data = new Array();
		$(slide).find('.cloud-placer').each(function(){
			data.push($(this).text());
		});
		return data;
	},
	input : function(slide) {
		var data = new Array();		
		$(slide).find('input.userinput').each(function(){
			data.push($(this).val());
		});
		return data;
	},
	open : function(slide) {
		if($(slide).children('textarea').length != 1) return;
		return $(slide).children('textarea')[0].value;
	},
	order : function(slide) {
		var data = new Array();		
		$(slide).find('.order-list li').each(function() { 
			data.push($(this).text());
		});
		return data;
	},
	pairsimage : function(slide) {
		var data = new Array(),
			options_l = new Array(), 
			options_r = new Array();
		
		$(slide).find('.column-left .order-list li').each(function() { 
			options_l.push($(this).data('file'));
		});
		$(slide).find('.column-right .order-list li').each(function() { 
			options_r.push($(this).text());
		});

		var len = Math.min(options_l.length, options_r.length);
		for(var i = 0; i < len; i++) {
			data.push([options_l[i],options_r[i]]);
		}
		
		return data;
	},
	pairs : function(slide) {
		var data = new Array(),
			options_l = new Array(), 
			options_r = new Array();
		
		$(slide).find('.column-left .order-list li').each(function() { 
			options_l.push($(this).text());
		});
		$(slide).find('.column-right .order-list li').each(function() { 
			options_r.push($(this).text());
		});

		var len = Math.min(options_l.length, options_r.length);
		for(var i = 0; i < len; i++) {
			data.push([options_l[i],options_r[i]]);
		}
		
		return data;
	},
	groups : function(slide) {
		var data = {};
		
		$(slide).find('.cloud-group').each(function() {
			var d = $(this).find('.cloud-placed');
			var key = $(this).find('label').text();
			data[key] = new Array(); 
			d.each(function() {
				data[key].push($(this).text());
			});
		});
		//alert(data);
		
		return data;
	},
	yofx : function(slide) {
		var data = new Array();
		
		$(slide).find('.check-line').each(function() {
			var d = $(this).children('span');
			if( $(d).hasClass('icon-check') || $(d).hasClass('icon-check-empty')) {				
				data.push($(d).hasClass('icon-check'));
			}
		});
		
		return data;
	},

};

var slideData = {};

//$.getJSON('js/slides.js', function(data){
//	slideData = data;
//});

function fetchSlideshowAnswers(slideId) {
	var data = {};
	$('.slide').each(function() {
		var id = $(this).data('slide-id'),
			type = $(this).data('slide-type');
		if(typeof slideId == 'undefined' || id!=slideId){
			return;
		}
		if(typeof type == 'undefined') return;
		if(typeof slideParsers[type] == 'undefined') return;
		
		$(this).find('div, li, span').removeClass('isCorrect').removeClass('isWrong');

		var answer = slideParsers[type](this);
		var results = parseData(slideData[id], answer, type, this);
		var oks = 0;
		var totals = 0;
		for(index in results){
			var result = results[index];
			if(result.right_answer!=null){
				totals++;
			}
			if(result.ok){
				oks++;
			}
		}
		if(totals>0){
			data[id] = Math.round(oks/totals*100);
		}
	});
	return data;
}

function parseData(slide, data, type, object) {
	var _result = new Array();

	switch(type) {
	
		case 'groups':		
			var places = $(object).find('.cloud-group .cloud-group-placer');
			
			$.each(places, function(k, place){				
				var cl = $(place).attr('id');		
				
				$(place).find('div.cloud-placed').each(function(){
					
					if( $(this).data('correct-group') == cl ){
						$(this).addClass('isCorrect');
					}else{
						$(this).addClass('isWrong');
					}
					
				});							
			});			
		break;
	
		case 'input':
		case 'clouds':
			var content = slide;
			if(content.text==undefined) return;

			var regs = /<userinput\s[^>]*>([^<]*)<\/userinput>/ig;
			var matched;
			k = 0;
			while(matched = regs.exec(content.text)){
				var matches = matched;
				var rightAnswer = matches[1];
				_result.push({
						answer: trimAnswer(data[k]),
						right_answer: trimAnswer(rightAnswer),
						ok: (trimAnswer(rightAnswer) == trimAnswer(data[k]))
				});
				if((trimAnswer(rightAnswer) == trimAnswer(data[k]))){
					$(object).find('.cloud-placer:eq('+k+')').addClass('isCorrect');
				}else{
					$(object).find('.cloud-placer:eq('+k+')').addClass('isWrong');
				}
				k++;
			}
			break;
		case 'order':
			content = slide;
			if(content.options==undefined) return;
			for(k in content.options) {
				var option = content.options[k];
				_result.push({
						answer: trimAnswer(data[k]),
						right_answer: trimAnswer(option.text),
						ok: trimAnswer(option.text) == trimAnswer(data[k])
				});
				if(trimAnswer(option.text) == trimAnswer(data[k])){
					$(object).find('.order-list li:eq('+k+')').addClass('isCorrect');
				}else{
					$(object).find('.order-list li:eq('+k+')').addClass('isWrong');
				}
			}
			break;
		case 'open':
			_result.push({
				answer: trimAnswer(data),
				right_answer: null,
				ok: null
			});
			break;
		case 'pairsimage':
		case 'pairs':
			content = slide;
			if(content.options==undefined) return;

			var pairs = content.options;
			for(k in data) {
				var row = data[k];
				for(j in pairs) {
					var pair = pairs[j];
					if( pair.left == row[0] ) {
							
						_result.push({
							answer: row,
							right_answer: [pair.left, pair.right],
							ok: (pair.right == row[1])
						});
						if((pair.right == row[1])){
							$(object).find('.column-right li:eq('+k+')').addClass('isCorrect');
							$(object).find('.column-left li:eq('+k+')').addClass('isCorrect');
						}else{
							$(object).find('.column-left li:eq('+k+')').addClass('isWrong');
							$(object).find('.column-right li:eq('+k+')').addClass('isWrong');
						}
					}
				}
			}
			break;
		case 'yofx':
			content = slide;
			if(content.options==undefined) return;

			for(k in content.options) {
				var row = content.options[k];
				data[k] = (data[k] == true) ? true : false;
				_result.push({
					answer: data[k],
					right_answer: (row.correct && true),
					ok: (row.correct && true) == data[k]
				});
								
				var a = 
					$(object).find('.check-line[data-key="'+k+'"] span[class^="icon-"]:first > .checked-indicator');
				
				if( $(object).find('.check-line[data-key="'+k+'"] .checked-indicator').length == 0)
				{
					$(object).find('.check-line[data-key="'+k+'"] span[class*="icon-"]:first').after('<span class="checked-indicator"></span>');
				}
				
				if( row.correct && true ){
					
					$(object).find('.check-line[data-key="'+k+'"]').addClass('shouldBeChecked');					
					
				}else{
					$(object).find('.check-line[data-key="'+k+'"]').addClass('notChecked');
					
					//niepowinno byc zaznaczone
					if( data[k] ){
						//a jest
						$(object).find('.check-line[data-key="'+k+'"]').addClass('isWrong');
					}
					
				}
				
				//powinno być zaznaczone a nie jest
				if( row.correct && true && !data[k]){
					$(object).find('.check-line[data-key="'+k+'"]').addClass('isWrong');
				}
				
				//powinno i jest
				if( row.correct && true && data[k]){
					$(object).find('.check-line[data-key="'+k+'"]').addClass('isCorrect');
				}
				
			}

			break;
		default:
			return;
	}
	return _result;
}

function trimAnswer(answer){
	return answer;
}

function fetchSlideshowResult(slideId){
	var result = fetchSlideshowAnswers(slideId);
}

function fetchSlideshowResults() {
	var results = fetchSlideshowAnswers();
	var oks = 0;
	var totals = 0;
	for(index in results){
		var result = results[index];
		totals++;
		if(result){
			oks = oks + result/100;
		}
	}
	return Math.round(oks/totals*100);
};


